[LeetCode] 26. Remove Duplicates from Sorted Array 有序数组中去除重复项

Given a sorted array nums, remove the duplicates in-place such that each element appear only once and return the new length.

Do not allocate extra space for another array, you must do this by modifying the input array in-place with O(1) extra memory.

Example 1:

2
nums
1
2

Example 2:

5
nums
0
1
2
3
4

Clarification:

Confused why the returned value is an integer but your answer is an array?

Note that the input array is passed in by reference, which means modification to the input array will be known to the caller as well.

Internally you can think of this:

// nums is passed in by reference. (i.e., without making a copy)
int len = removeDuplicates(nums);

// any modification to nums in your function would be known by the caller.
// using the length returned by your function, it prints the first len elements.
for (int i = 0; i < len; i++) {
    print(nums[i]);
}

去除有序数组中的重复项,返回新数组的长度,要求in-place,O(1)的额外空间。

解法:双指针Two Pointers,一个指针遍历数组所有元素,一个指针指向遍历后的不重复元素的边界。

Java:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
class Solution {
    public static int removeDuplicatesNaive(int[] A) {
      if (A.length < 2)
        return A.length;
 
      int j = 0;
      int i = 1;
 
      while (i < A.length) {
        if (A[i] == A[j]) {
          i++;
        } else {
          j++;
          A[j] = A[i];
          i++;
        }
      }
 
      return j + 1;
    }
}

Python:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class Solution:
    # @param a list of integers
    # @return an integer
    def removeDuplicates(self, A):
        if not A:
            return 0
         
        last, i = 0, 1
        while i < len(A):
            if A[last] != A[i]:
                last += 1
                A[last] = A[i]
            i += 1
             
        return last + 1

C++:

1
2
3
4
5
6
7
8
9
10
11
12
class Solution {
public:
    int removeDuplicates(vector<int>& nums) {
        if (nums.empty()) return 0;
        int pre = 0, cur = 0, n = nums.size();
        while (cur < n) {
            if (nums[pre] == nums[cur]) ++cur;
            else nums[++pre] = nums[cur++];
        }
        return pre + 1;
    }
};

C++:

1
2
3
4
5
6
7
8
9
10
class Solution {
    public:
    int removeDuplicates(int A[], int n) {
        if(n < 2) return n;
        int id = 1;
        for(int i = 1; i < n; ++i)
            if(A[i] != A[i-1]) A[id++] = A[i];
        return id;
    }
};

   

 

类似题目:

[LeetCode] 27. Remove Element 移除元素

[LeetCode] 283. Move Zeroes 移动零

[LeetCode] 80. Remove Duplicates from Sorted Array II 有序数组中去除重复项 II

  

All LeetCode Questions List 题目汇总

 

posted @   轻风舞动  阅读(480)  评论(0编辑  收藏  举报
编辑推荐:
· .NET Core 中如何实现缓存的预热?
· 从 HTTP 原因短语缺失研究 HTTP/2 和 HTTP/3 的设计差异
· AI与.NET技术实操系列:向量存储与相似性搜索在 .NET 中的实现
· 基于Microsoft.Extensions.AI核心库实现RAG应用
· Linux系列:如何用heaptrack跟踪.NET程序的非托管内存泄露
阅读排行:
· TypeScript + Deepseek 打造卜卦网站:技术与玄学的结合
· 阿里巴巴 QwQ-32B真的超越了 DeepSeek R-1吗?
· 【译】Visual Studio 中新的强大生产力特性
· 10年+ .NET Coder 心语 ── 封装的思维:从隐藏、稳定开始理解其本质意义
· 【设计模式】告别冗长if-else语句:使用策略模式优化代码结构
点击右上角即可分享
微信分享提示